<?php
/**
 * @revision    $Id: app_globprefs.php,v 1.3.2.2 2004/07/21 13:25:19 zak Exp $
 * @project     GMapFactory
 * @author      William A. Bronsema, C.E.T. (bronsema@dmsolutions.ca)
 * @contact     DM Solutions Group Inc. (www.dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * 
 */

// the application root directory (modify depending on your local installation)
// it should contain the absolute path to the application directory
define( "APP_PATH", "./" );

// define a temp directory to write temp shapefiles 
// directory must be writeable
define( "TMP_DIR", APP_PATH."tmp/" );

// define the map file to be used in this application
define( "MAPFILE", "?" );

// define the height and width of the map
define( "MAP_WIDTH", "450" );
define( "MAP_HEIGHT", "350" );

// define the height and width of the keymap
define( "KEYMAP_WIDTH", "100" );
define( "KEYMAP_HEIGHT", "75" );

// define the maximum extents
define( "MAX_EXT_MINX", ? );
define( "MAX_EXT_MINY", ? );
define( "MAX_EXT_MAXX", ? );
define( "MAX_EXT_MAXY", ? );

// define the path and filename of the ROSA applet (must be relative)
define( "ROSA_FILE", "./rosa/rosa.jar" );

// define the zoom out factor to be used
define( "ZOOMOUT_FACTOR", ? );

// define the zoom in factor to be used
define( "ZOOMIN_FACTOR", ? );

// define the smallest rectangle size (in pixels) for zooming in, 
// otherwise treat as a point
define( "MIN_RECT", 5 );

// include the utilties file for misc functions
include_once( APP_PATH."wrapper/utilities.php" );
include_once( APP_PATH."logger/logfile.php" );
include_once( APP_PATH."logger/error_manager.php" );
include_once( APP_PATH."logger/logger.php" );
include_once( APP_PATH."wrapper/map_session.php" );
include_once( APP_PATH."wrapper/map_navigator.php" );
include_once( APP_PATH."wrapper/map_query.php" );

// create new logfile object (customize parameters)
$oLogFile = new LogFile(TMP_DIR."log.txt", LOG_TO_FILE, 1);

// set the max log level (adjust as necessary)
$oLogFile->setMaxLogLevel( LOG_ALL );

// create new error manager object
$oErrorManager = new ErrorManager();

// create a new map session object
$oMapSession = new MapSession_R;

// set the global log file and error manager
$oMapSession->setLogFile( $oLogFile );
$oMapSession->setErrorManager( $oErrorManager );

// set the temp directory for the map session
$oMapSession->setTempDir( TMP_DIR );

// set the maximum extents to limit navigation
$oMapSession->setMaxExtents( MAX_EXT_MINX, MAX_EXT_MINY, MAX_EXT_MAXX, 
                                                            MAX_EXT_MAXY );
// create a new map navigator object
$oMapNavigator = new MapNavigator( $oMapSession );

// set the global log file and error manager
$oMapNavigator->setLogFile( $oLogFile );
$oMapNavigator->setErrorManager( $oErrorManager );

// create a new map query object
$oMapQuery = new MapQuery( $oMapSession );

// set the global log file and error manager
$oMapQuery->setLogFile( $oLogFile );
$oMapQuery->setErrorManager( $oErrorManager );

/* ============================================================================
 * Load the mapscript module
 * ========================================================================= */
if (PHP_OS == "WINNT" || PHP_OS == "WIN32")
{
    // windows
    $szModule = "php_mapscript_42.dll";
}
else
{
    // unix
    $szModule = "php_mapscript_42.so";
}

// ensure that the mapscript module is loaded (using function from utilties.php)
load_module( "MapScript", $szModule );

?>
