<?php
/**
 * MapBrowser application
 *
 * @project     MapLab
 * @revision    $Id: map.php,v 1.39.2.1 2004/07/15 19:43:07 zak Exp $
 * @purpose     This page contains supporting php functions.
 * @author      William A. Bronsema, C.E.T. (bronsema@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*****************************************************************************
 * $Log: map.php,v $
 * Revision 1.39.2.1  2004/07/15 19:43:07  zak
 * stopped undefined var warnings
 *
 * Revision 1.39  2003/03/12 21:11:59  sacha
 * Removed top. in some javascript functions
 *
 * Revision 1.38  2002/11/04 15:08:42  sacha
 * Add the abiliti to upload and download context file in mapbrowser
 *
 * Revision 1.37  2002/08/08 15:02:35  bronsema
 * Stream-lined drawMap function to set location of drawMap.php
 * once.
 *
 * Revision 1.36  2002/08/08 02:21:40  bronsema
 * Switched to generic drawmap.php
 *
 * Revision 1.35  2002/07/31 23:34:31  bronsema
 * Revert back to single query button
 *
 * Revision 1.34  2002/07/31 14:12:04  jmckenna
 * - changed query alt tag (JM)
 *
 * Revision 1.33  2002/07/31 02:35:21  bronsema
 * Added default IMAGEURL & IMAGEPATH from XML if missing in map.
 *
 * Revision 1.32  2002/07/24 19:13:26  bronsema
 * updated rectangle query image
 *
 * Revision 1.31  2002/07/24 02:43:54  bronsema
 * Added rectangle query button to ROSA
 *
 * Revision 1.30  2002/07/24 00:55:47  bronsema
 * Updated to standard Icons
 *
 * Revision 1.29  2002/07/19 13:40:34  jmckenna
 * - changed alt text to 'point query' (JM)
 *
 * Revision 1.28  2002/07/06 01:15:49  bronsema
 * Fixed custom view zoom error
 *
 * Revision 1.27  2002/07/05 14:56:18  pspencer
 * fixed map display
 *
 * Revision 1.26  2002/07/05 14:40:18  pspencer
 * reversed last change
 *
 * Revision 1.24  2002/07/04 20:10:12  pspencer
 * query fixes
 *
 * Revision 1.23  2002/06/30 20:15:01  pspencer
 * initial cut at register_globals=off and new session model
 *
 * Revision 1.22  2002/06/13 14:10:27  sacha
 * Change copywrite
 *
 * Revision 1.21  2002/06/06 03:53:43  bronsema
 * Fixed typo in http_form_vars["NotFirstLoad"] variable from last fix.
 *
 * Revision 1.20  2002/06/06 03:39:47  bronsema
 * Fixed bug 1086 - First zoom in HTML was having no affect on main map.
 *
 * Revision 1.19  2002/06/06 02:28:15  bronsema
 * Fixed the  problem with the default ROSA/HTML (bug 1085)
 *
 * Revision 1.18  2002/05/29 15:30:57  pspencer
 * fixed references to global log file and error manager
 *
 * Revision 1.14  2002/05/28 20:31:17  pspencer
 * updated state key handling
 *
 * Revision 1.13  2002/05/28 11:49:55  bronsema
 * There was a $ missing on a variable to trigger a log message.
 *
 * Revision 1.12  2002/05/27 21:06:46  pspencer
 * fixed integration between maplab and mapbrowser
 *
 * Revision 1.11  2002/05/25 03:10:50  pspencer
 * added gszCurrentState to session variables
 *
 * Revision 1.10  2002/05/23 00:35:07  bronsema
 * Fixed HTML zoomout command to center on the click
 *
 * Revision 1.9  2002/05/22 17:55:40  bronsema
 * Added HTML mode functionality
 *
 * Revision 1.8  2002/05/22 14:14:08  bronsema
 * Removed the maximum extent constraint
 *
 * Revision 1.7  2002/05/22 13:10:44  bronsema
 * Changed "Full View" to "Initial View"
 *
 * Revision 1.6  2002/05/21 17:18:45  bronsema
 * Added generate keymap functionality
 *
 * Revision 1.5  2002/05/21 04:48:07  bronsema
 * Added quering capabilities
 *
 * Revision 1.4  2002/05/19 04:23:14  bronsema
 * Streamlined javascript interaction
 *
 * Revision 1.3  2002/05/18 00:44:41  bronsema
 * Added projection and map size dialogs and functionality
 *
 * Revision 1.2  2002/05/16 20:56:23  bronsema
 * Added custom and max extent capabilities
 *
 * Revision 1.1  2002/05/16 16:52:27  bronsema
 * Initial addition
 *
 *****************************************************************************/
// include the global preferences
include_once( "./globprefs.php" );

// include wrapper file(s)
include_once( COMMON."wrapper/map_session.php" );
include_once( COMMON."wrapper/map_navigator.php" );
include_once( COMMON."wrapper/map_query.php" );

// ensure that the mapscript module is loaded
if (!extension_loaded("MapScript")) dl($gszMapscriptModule);


/* ============================================================================
 * Setup the map session, navigator, & query classes
 * ========================================================================= */

// create a new map session object
$oMapSession = new MapSession_RW;

// set the global log file and error manager
$oMapSession->setLogFile( $gLogFile );
$oMapSession->setErrorManager( $_SESSION["gErrorManager"] );

// set the temp directory for the map session
$oMapSession->setTempDir( $gszTmpMapPath );

// create a new map navigator object
$oMapNavigator = new MapNavigator( $oMapSession );

// set the global log file and error manager
$oMapNavigator->setLogFile( $gLogFile );
$oMapNavigator->setErrorManager( $_SESSION["gErrorManager"] );

// create a new map query object
$oMapQuery = new MapQuery( $oMapSession );

// set the global log file and error manager
$oMapQuery->setLogFile( $gLogFile );
$oMapQuery->setErrorManager( $_SESSION["gErrorManager"] );

/* ============================================================================
 * Build an array with the HTTP GET or POST parameters.
 * ========================================================================= */
$http_form_vars = (count($_POST) > 0) ?
                  $_POST : ((count($_GET) > 0) ? $_GET : array() );

/* ============================================================================
 * Interpret default navigation mode.
 * ========================================================================= */
if (!isset($http_form_vars["NotFirstLoad"])) $http_form_vars["NotFirstLoad"] = false;
if ( $http_form_vars["NotFirstLoad"] == 1 )
    $_SESSION["gszNavigationMode"] = $http_form_vars['RosaMode'];

/* ============================================================================
 * Set the maximum extents of the session object
 * ========================================================================= */
if ( strlen( trim( $_SESSION["gszMaxExtents"] ) ) > 0 )
{
    // use session extents
    $adExtents = explode( ",", strval( $_SESSION["gszMaxExtents"] ) );

    // set the maximum extents to limit navigation
    //$oMapSession->setMaxExtents( $adExtents[0], $adExtents[1], $adExtents[2],
                                                            //$adExtents[3] );
}
else
{
    // open the map and use initial extents
    $oMapSession->restoreState( "", $_SESSION["gszMapName"], dirname( $_SESSION["gszMapName"] ) );

    // set the maximum extents to limit navigation
    //$oMapSession->setMaxExtents( $oMapSession->oMap->extent->minx,
                                 //$oMapSession->oMap->extent->miny,
                                 //$oMapSession->oMap->extent->maxx,
                                 //$oMapSession->oMap->extent->maxy);

    // save the extents in a session var
    $_SESSION["gszMaxExtents"] = $oMapSession->oMap->extent->minx.",".
                     $oMapSession->oMap->extent->miny.",".
                     $oMapSession->oMap->extent->maxx.",".
                     $oMapSession->oMap->extent->maxy;

}

/* ============================================================================
 * If the custom view is not set then set to max
 * ========================================================================= */
if ( strlen( trim( $_SESSION["gszCustExtents"] ) ) == 0 )
    $_SESSION["gszCustExtents"] = $_SESSION["gszMaxExtents"];

/* ============================================================================
 * Re-instate the previous map state
 * ========================================================================= */
// determine previous state key
//if ( isset( $http_form_vars["PrevStateKey"] ) )
//{
//    $szPrevStateKey = $http_form_vars["PrevStateKey"];
//    $_SESSION["gszCurrentState"] = $szPrevStateKey;
//}
//else
//    $szPrevStateKey = $_SESSION["gszCurrentState"];

// restore the previous state
$oMapSession->restoreState( $_SESSION["gszCurrentState"], $_SESSION["gszMapName"],
                                                    dirname( $_SESSION["gszMapName"] ) );

// Check if image path and tmp urd directory is set.
// If not use the one specified in .xml config file.
if ($oMapSession->oMap->web->imagepath == "" && $_SESSION["gszTmpImgPath"] != "")
    $oMapSession->oMap->web->set("imagepath", $_SESSION["gszTmpImgPath"]);

if ($oMapSession->oMap->web->imageurl == "" && $_SESSION["gszTmpWebImgPath"] != "")
    $oMapSession->oMap->web->set("imageurl", $_SESSION["gszTmpWebImgPath"]);                                                    
                                                    
/* ============================================================================
 * Set the custom view if required
 * ========================================================================= */
if ( isset($http_form_vars["SetCustView"]) && $http_form_vars["SetCustView"] == 1 )
{
    // use current extents
    $_SESSION["gszCustExtents"] = $oMapSession->oMap->extent->minx.",".
                      $oMapSession->oMap->extent->miny.",".
                      $oMapSession->oMap->extent->maxx.",".
                      $oMapSession->oMap->extent->maxy;
}

/* ============================================================================
 * Set the maximum extent if required
 * ========================================================================= */
if ( isset($http_form_vars["SetMaxExtent"]) && $http_form_vars["SetMaxExtent"] == 1 )
{
    // set the maximum extents to limit navigation
    //$oMapSession->setMaxExtents( $oMapSession->oMap->extent->minx,
                                 //$oMapSession->oMap->extent->miny,
                                 //$oMapSession->oMap->extent->maxx,
                                 //$oMapSession->oMap->extent->maxy);

    // use current extents
    $_SESSION["gszMaxExtents"] = $oMapSession->oMap->extent->minx.",".
                     $oMapSession->oMap->extent->miny.",".
                     $oMapSession->oMap->extent->maxx.",".
                     $oMapSession->oMap->extent->maxy;
}

/* ============================================================================
 * Process map size.
 * ========================================================================= */
// define the height and width of the map
$nTmpMapWidth = intval( $oMapSession->oMap->width );
$nTmpMapHeight = intval( $oMapSession->oMap->height );
define( "MAP_WIDTH", $nTmpMapWidth );
define( "MAP_HEIGHT", $nTmpMapHeight );

/* ============================================================================
 * Process keymap size.
 * ========================================================================= */
// define the height and width of the keymap
$nTmpKeyMapWidth = intval( $oMapSession->oMap->reference->width );
$nTmpKeyMapHeight = intval( $oMapSession->oMap->reference->height );
if ( $nTmpKeyMapWidth == 0 ) $nTmpKeyMapWidth = 100;
if ( $nTmpKeyMapHeight == 0 ) $nTmpKeyMapHeight = 75;
define( "KEYMAP_WIDTH", $nTmpKeyMapWidth );
define( "KEYMAP_HEIGHT", $nTmpKeyMapHeight );

/* ============================================================================
 * Check if the mainmap was clicked and update the co-ordinates
 * ========================================================================= */
if ( isset( $http_form_vars[ "mainmap_x" ] ) &&
     isset( $http_form_vars[ "mainmap_y" ] ) )
{
    // set the values into the nav hidden variable
    $http_form_vars["INPUT_COORD"] = $http_form_vars[ "mainmap_x" ].",".
                                     $http_form_vars[ "mainmap_y" ];
}

/* ============================================================================
 * Process navigation commands.
 * ========================================================================= */
// check for pan commands
if ( isset($http_form_vars["Pan_North_x"]) &&
        strlen( trim( $http_form_vars["Pan_North_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "PAN_N";
}
if ( isset($http_form_vars["Pan_East_x"] ) &&
     strlen( trim( $http_form_vars["Pan_East_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "PAN_E";
}
if ( isset($http_form_vars["Pan_South_x"]) &&
    strlen( trim( $http_form_vars["Pan_South_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "PAN_S";
}
if ( isset($http_form_vars["Pan_West_x"]) &&
     strlen( trim( $http_form_vars["Pan_West_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "PAN_W";
}

// check for the zoom full or cust HTML button click
if (  isset($http_form_vars["Zoom_Full_x"]) &&
    strlen( trim( $http_form_vars["Zoom_Full_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "ZOOM_ALL";
}
if (  isset($http_form_vars["Zoom_Cust_x"]) &&
    strlen( trim( $http_form_vars["Zoom_Cust_x"] ) ) > 0 )
{
    // check mode and set appropriate vars
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
        $http_form_vars["INPUT_COORD"] = "0,0";
    else
        $http_form_vars[ "mainmap_x" ] = "0";

    // set the command
    $http_form_vars["ROSA_CMD"] = "ZOOM_CUST";
}

if (  isset($http_form_vars["ZOOM_IN_x"]) &&
    strlen( trim( $http_form_vars["ZOOM_IN_x"] ) ) > 0 )
{
    $http_form_vars['ROSA_CMD'] = "ZOOM_IN";
    $http_form_vars["mainmap_x"] = MAP_WIDTH/2;
    $http_form_vars["mainmap_y"] = MAP_HEIGHT/2;
    // set the values into the nav hidden variable
    $http_form_vars["INPUT_COORD"] = $http_form_vars[ "mainmap_x" ].",".
                                     $http_form_vars[ "mainmap_y" ];
}

if (  isset($http_form_vars["ZOOM_OUT_x"]) &&
    strlen( trim( $http_form_vars["ZOOM_OUT_x"] ) ) > 0 )
{
    $http_form_vars['ROSA_CMD'] = "ZOOM_OUT";
    $http_form_vars["mainmap_x"] = MAP_WIDTH/2;
    $http_form_vars["mainmap_y"] = MAP_HEIGHT/2;
    // set the values into the nav hidden variable
    $http_form_vars["INPUT_COORD"] = $http_form_vars[ "mainmap_x" ].",".
                                     $http_form_vars[ "mainmap_y" ];
}

// process navigation requests
if ( ( ( $_SESSION["gszNavigationMode"] != "ROSA" &&
       isset( $http_form_vars[ "mainmap_x" ] ) ) ||
       ( $_SESSION["gszNavigationMode"] == "ROSA" ) &&
       isset( $http_form_vars["INPUT_COORD"]) &&
       $http_form_vars["INPUT_COORD"] != "" 
        ))

{
    // check the naviagtion command and process
    $xNavigate = checkNavigation($oMapNavigator,$http_form_vars["ROSA_CMD"],
                 $http_form_vars["INPUT_COORD"], $oMapQuery,
                 $http_form_vars['QueryLayer'],
                 $http_form_vars['RosaMode'] );

    // set the query string variable
    if ( strlen( $xNavigate ) > 1 )
        $szQueryString = $xNavigate;
    else
        $szQueryString = "";

    // check for success
    if (!$xNavigate )
    {
        // give error if failed
        $oMapNavigator->error(ERROR_NOTICE,"checkNavigation Failed");
    }
}

/* ============================================================================
 * process keymap click
 * ========================================================================= */
if ( isset( $http_form_vars["keymap_x"] ) )
{
    // navigate via the keymap
    keymapNavigate ($oMapSession, $oMapNavigator, $http_form_vars["keymap_x"],
                     $http_form_vars["keymap_y"], $_SESSION["gszMaxExtents"] );
}

/* ============================================================================
 * Save the current state.
 * ========================================================================= */
$_SESSION["gszCurrentState"] = $oMapSession->saveState();

//close the session so other pages can load now.
session_write_close();

/* ============================================================================
 * Draw reference map.
 * ========================================================================= */
$szTmpCwd = getcwd();
chdir( dirname( $_SESSION["gszMapName"] ) );

// only draw if exists
if ( file_exists( $oMapSession->oMap->reference->image ) &&
     strlen( trim( $oMapSession->oMap->reference->image ) ) > 0 )
    $urlReference = drawKeymap( $oMapSession, KEYMAP_WIDTH, KEYMAP_HEIGHT );

// check
if ( $urlReference != "" )
    $szReference = "<td><input type=image name=\"keymap\" src=\"$urlReference".
    "\" width=".KEYMAP_WIDTH." height=".KEYMAP_HEIGHT." border=0></td>";
else
    $szReference = "<td align=center><font face=\"Arial, Helvetica, ".
    "sans-serif\" size=1><b>No reference map<br>specified</b></font></td>";

// return to cwd
chdir( $szTmpCwd );
/* ============================================================================
 * Render the map.
 * ========================================================================= */
/*if ( $_SESSION["gszNavigationMode"] == "ROSA" )
{
    // draw map with query results
    $imgMainMap = $oMapSession->oMap->drawQuery();
    // save the map image
    $urlMainMap = $imgMainMap->saveWebImage(IMAGE_TYPE, 0, 0, -1);
}
*/
// set the scale value to display
$nScale = $oMapSession->oMap->scale;


/**
 * This function determines which navigation button is to be selected
 *
 * @param $szRosaCmd String - value of 'ROSA_CMD' form variable
 * @return String - value to be selected
 **/
function checkSelected($szRosaCmd)
{
    // return the appropriate button name to select based on last ROSA command
    switch ($szRosaCmd)
    {
    // recenter
    case "RECENTRE":
        return "recentre";
        break;
    // query
    case "QUERY":
        return "pquery";
        break;        
    case "ZOOM_OUT":
        if ( $_SESSION["gszNavigationMode"] != "ROSA" )
        {
            return "zoomout";
            break;
        }
    // all other
    default:
        return "zoomin";
    }
}

/**
 * This function determines which navigation button is to be selected
 *
 * @param $oMapNavigator object - The navigator object.
 * @param $szRosaCmd string - The command to check.
 * @param $szInputCoords string - De-limited string of coordinates.
 * @param $szQueryLayer string - Layer to query.
 * @param $nROSA integer - flag to indicate if ROSA is used.
 * @return mixed - true if navigation selected or the results of a query.
 **/
function checkNavigation($oMapNavigator,$szRosaCmd, $szInputCoords, $oMapQuery,
                         $szQueryLayer, $nROSA)
{
    // only process if coordinates are given
    if (isset($szInputCoords))
    {
        // process coordinates
        $aszMinMax = explode(";", $szInputCoords);
        $adMin = explode(",", $aszMinMax[0]);
        $adMax = explode(",", $aszMinMax[1]);
    }
    // process commands if necessary
    if ( $szRosaCmd != "" && $szRosaCmd != null )
    {
        // check individual command
        switch ($szRosaCmd)
        {
        // zoom in
        case "ZOOM_IN":
            //check if for point click
            $nDeltaX = $adMax[0] - $adMin[0];
            $nDeltaY = $adMax[1] - $adMin[1];

            // if the rectangle is very small then treat as a point click
            if ($nDeltaX < MIN_RECT && $DeltaY < MIN_RECT)
                $oMapNavigator->zoomPoint(ZOOMIN_FACTOR, $adMin[0], $adMin[1]);
            else
                $oMapNavigator->zoomRectangle($adMin[0],$adMin[1],$adMax[0],
                                                                    $adMax[1]);
            return true;
            break;

        // zoom out
        case "ZOOM_OUT":
            if ( $nROSA == "ROSA" )
                $oMapNavigator->zoomOut( ZOOMOUT_FACTOR );
            else
                $oMapNavigator->zoomOut( ZOOMOUT_FACTOR, $adMin[0], $adMin[1] );
            return true;
            break;

        // zoom all
        case "ZOOM_ALL":
            // get extents
            $adMax = explode( ",", $_SESSION["gszMaxExtents"] );

            // zoom
            $oMapNavigator->oSession->oMap->setextent( $adMax[0], $adMax[1],
                                                    $adMax[2], $adMax[3] );
            return true;
            break;

        // zoom cust
        case "ZOOM_CUST":

            // get extents
            //$adCust = explode( ",", $szCustExtents );
            $adCust = explode( ",", $_SESSION["gszCustExtents"] );

            // zoom
            $oMapNavigator->oSession->oMap->setextent( $adCust[0], $adCust[1],
                                                    $adCust[2], $adCust[3] );
            return true;
            break;

        // pan north
        case "PAN_N":
            $oMapNavigator->pan( NORTH, 0.75 );
            return true;
            break;

        // pan east
        case "PAN_E":
            $oMapNavigator->pan( EAST, 0.75 );
            return true;
            break;

        // pan south
        case "PAN_S":
            $oMapNavigator->pan( SOUTH, 0.75 );
            return true;
            break;

        // pan west
        case "PAN_W":
            $oMapNavigator->pan( WEST, 0.75 );
            return true;
            break;

        // recentre
        case "RECENTRE":
            $oMapNavigator->recentre($adMin[0],$adMin[1]);
            return true;
            break;

        // query
        case "QUERY":

            //$szResults = "?minx=$adMin[0]&miny=$adMin[1]&maxx=$adMax[0]&maxy=$adMax[1]";

            // return results
            return "QUERY";

            // exit switch
            break;

        // otherwise navigation failed
        default:
            return false;
        }
    }
    else
    {
        // no navigation to perform so return true
        return true;
    }
}

/**
 * This function returns a Mapscript image object of the keymap.
 *
 * @param $oSession object - The current map session object.
 * @param string $nWidth integer - The width if the keymap.
 * @param string $nHeight integer - The height of the keymap.
 * @return object - Image object of the keymap.
 **/
function drawKeymap( $oSession, $nWidth = "", $nHeight = "" )
{
    // log entry
    $oSession->logFuncStart( LOG_VERBOSE, "drawKeymap() starting" );

    // get the session map object
    $oMap = $oSession->getMapObj();

    // get the reference map object
    $oRef = $oMap->reference;

    // set the width and height if necessary
    if ( $nWidth != "" && $nHeight != "" )
    {
        $oRef->set( "width", $nWidth );
        $oRef->set( "height", $nHeight );
    }

    // draw the keymap
    $imgKeyMap = $oMap->drawreferencemap();

    // get the image handle
    $url = $imgKeyMap->saveWebImage();

    // log exit
    $oSession->logFuncEnd( LOG_ALL, "drawKeymap() done" );

    // return the image handle
    return $url;

// end drawKeymap function
}

/**
 * This function takes the keymap click co-ordinates and recenters the map
 * accordingly.
 *
 * @param $oSession object - The map session object.
 * @param $oNavigate object - The map navigation object.
 * @param $nX integer - The keymap X click position in pixels.
 * @param $nY integer - The keymap Y click position in pixels.
 * @param $dMaxExtents string - A comma de-limited string of max extents.
 **/
function keymapNavigate ( $oSession, $oNavigate, $nX, $nY, $dMaxExtents )
{
    // log entry
    $oSession->logFuncStart( LOG_VERBOSE, "keymapNavigate() starting" );

    // use session extents
    //$adExtents = explode( ",", strval( $dMaxExtents ) );

    // get local map object
    $oMap = $oSession->getMapObj();

    // use the keymap extents
    $adExtents[0] = $oMap->reference->extent->minx;
    $adExtents[1] = $oMap->reference->extent->miny;
    $adExtents[2] = $oMap->reference->extent->maxx;
    $adExtents[3] = $oMap->reference->extent->maxy;

    // get x click position
    $nMapXClick = keymapToMap( $oMap->width, $oMap->extent->minx,
                        $oMap->extent->maxx, $adExtents[0], $adExtents[2], $nX,
                                            KEYMAP_WIDTH, $oSession, true);
    // get y click position
    $nMapYClick = keymapToMap( $oMap->height, $oMap->extent->miny,
                        $oMap->extent->maxy, $adExtents[1], $adExtents[3], $nY,
                                            KEYMAP_HEIGHT, $oSession, false);
    // recenter to the click position
    $oNavigate->recentre( $nMapXClick, $nMapYClick );

    // log the x and y parameters
    $oSession->log( LOG_QUIET, "X & Y Parameters are: $nMapXClick,
                                                                $nMapYClick");
    // log exit
    $oSession->logFuncEnd( LOG_ALL, "keymapNavigate() done" );
}

/**
 * This function calculates the corresponding map click given a keymap click.
 *
 * @param $nMapPix
 * @param $nMapMinGeo
 * @param $nMapMaxGeo
 * @param $nMapMinGeoMax
 * @param $nMapMaxGeoMax
 * @param $nKeyPixClick
 * @param $nKeyPix
 * @param $oSession
 * @param $bX
 * @return integer - The map click position in pixels.
 **/
function keymapToMap ( $nMapPix, $nMapMinGeo, $nMapMaxGeo, $nMapMinGeoMax,
                        $nMapMaxGeoMax, $nKeyPixClick, $nKeyPix, $oSession,
                        $bX )
{
    // log entry
    $oSession->logFuncStart( LOG_VERBOSE, "keymapToMap() starting" );

    // calculate the difference in extents
    $nMapGeo = $nMapMaxGeo - $nMapMinGeo;
    $nMapGeoMax = $nMapMaxGeoMax - $nMapMinGeoMax;

    // calculate the pixel value of the maximum map extents (i.e. width or
    // height of map at maximum extents)
    $nMapPixMax = ( $nMapPix * $nMapGeoMax ) / $nMapGeo;

    // calculate the map click distance
    $dClickDistance =  ( $nKeyPixClick * $nMapPixMax ) / $nKeyPix;

    // calculate the value to translate the origin
    if ($bX)
        $dDeltaOrigin = (($nMapMinGeo - $nMapMinGeoMax) * $nMapPix) / $nMapGeo;
    else
        $dDeltaOrigin = (($nMapMaxGeoMax - $nMapMaxGeo) * $nMapPix) / $nMapGeo;

    // calculate the return value
    $dReturnValue = $dClickDistance - $dDeltaOrigin;

    // log exit
    $oSession->logFuncEnd( LOG_ALL, "keymapToMap() done" );

    // return the results
    return $dReturnValue;

// end keymapToMap function
}

/**
 * This function outputs the html code that draws the main map either by applet
 * or by url.
 *
 * @param $szCommand string - The last command issued on the map.
 * @param $oSession object - The current map session object.
 * @param $szInputCoords string - List of input coordinates.
 **/
function drawMainMap( $szCommand, $oSession, $szInputCoords )
{
    // get the current map object
    $oMap = $oSession->getMapObj();

    // get the selected toolbar button
    $szButton = checkSelected($szCommand);
    
    // determine if a query is to be run
    if ( $szCommand == "QUERY" )
    {
        $nRunQuery = 1;
    }
    else
    {
        $nRunQuery = 0;    
    }
    
    // set the drawmap.php's location
    $szLocation = COMMON."wrapper/drawmap.php?".SID.
            "&map_session_mode=1&run_query=".$nRunQuery."&gszQueryCoords=".
            $szInputCoords."&bob=".md5(uniqid(rand(),1));    
    
    // draw the the map as an applet of ROSA is on
    if ( $_SESSION["gszNavigationMode"] == "ROSA" )
    {
        // draw the map as a ROSA applet
        echo "<td width=".$oMap->width." height=".$oMap->height.">";
        echo "<applet name=\"RosaApplet\" archive=\"".ROSA_FILE.
            "\" code=\"Rosa2000\" width=\"".$oMap->width."\" height=\"".
            $oMap->height."\" MAYSCRIPT>";
        echo "<param name=\"TB_POSITION\" value=\"right\">\n";
        echo "<param name=\"TB_ALIGN\" value=\"top\">\n";
        echo "<param name=\"IMG_URL\" value=\"".$szLocation."\">\n";
        echo "<param name=\"INP_FORM_NAME\" value=\"main\">\n";
        echo "<param name=\"TB_BUTTONS\" value=\"zoomin|zoomout|zoomall|".
            "zoomcust|recentre|pquery\">\n";
        echo "<param name=\"INP_TYPE_NAME\" value=\"INPUT_TYPE\">\n";
        echo "<param name=\"INP_COORD_NAME\" value=\"INPUT_COORD\">\n";
        echo "<param name=\"TB_SELECTED_BUTTON\" value=\"".$szButton."\">\n";
        echo "<param name=\"TB_BUT_zoomin_IMG\" value=\"./images/".
            "tool_zoomin_1.gif\">\n";
        echo "<param name=\"TB_BUT_zoomin_IMG_PR\" value=\"./images/".
            "tool_zoomin_2.gif\">\n";
        echo "<param name=\"TB_BUT_zoomin_HINT\" value=".
            "\"Zoom In (point/rectangle)\">\n";
        echo "<param name=\"TB_BUT_zoomin_INPUT\" value=\"auto_rect\">\n";
        echo "<param name=\"TB_BUT_zoomin_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_zoomin_VALUE\" value=\"ZOOM_IN\">\n";
        echo "<param name=\"TB_BUT_zoomout_IMG\" value=\"./images/".
            "tool_zoomout_1.gif\">\n";
        echo "<param name=\"TB_BUT_zoomout_IMG_PR\" value=\"./images/".
            "tool_zoomout_2.gif\">\n";
        echo "<param name=\"TB_BUT_zoomout_HINT\" value=\"Zoom Out\">\n";
        echo "<param name=\"TB_BUT_zoomout_INPUT\" value=\"submit\">\n";
        echo "<param name=\"TB_BUT_zoomout_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_zoomout_VALUE\" value=\"ZOOM_OUT\">\n";
        echo "<param name=\"TB_BUT_zoomall_IMG\" value=\"./images/".
            "tool_zoomfull_1.gif\">\n";
        echo "<param name=\"TB_BUT_zoomall_IMG_PR\" value=\"./images/".
            "tool_zoomfull_2.gif\">\n";
        echo "<param name=\"TB_BUT_zoomall_HINT\" value=".
            "\"Zoom to Initial View\">\n";
        echo "<param name=\"TB_BUT_zoomall_INPUT\" value=\"submit\">\n";
        echo "<param name=\"TB_BUT_zoomall_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_zoomall_VALUE\" value=\"ZOOM_ALL\">\n";
        echo "<param name=\"TB_BUT_zoomcust_IMG\" value=\"./images/".
            "tool_zoom_custom_1.gif\">\n";
        echo "<param name=\"TB_BUT_zoomcust_IMG_PR\" value=\"./images/".
            "tool_zoom_custom_2.gif\">\n";
        echo "<param name=\"TB_BUT_zoomcust_HINT\" value=".
            "\"Zoom to Custom View\">\n";
        echo "<param name=\"TB_BUT_zoomcust_INPUT\" value=\"submit\">\n";
        echo "<param name=\"TB_BUT_zoomcust_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_zoomcust_VALUE\" value=\"ZOOM_CUST\">\n";
        echo "<param name=\"TB_BUT_recentre_IMG\" value=\"./images/".
            "tool_recentre_1.gif\">\n";
        echo "<param name=\"TB_BUT_recentre_IMG_PR\" value=\"./images/".
            "tool_recentre_2.gif\">\n";
        echo "<param name=\"TB_BUT_recentre_HINT\" value=\"Recentre\">\n";
        echo "<param name=\"TB_BUT_recentre_INPUT\" value=\"auto_point\">\n";
        echo "<param name=\"TB_BUT_recentre_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_recentre_VALUE\" value=\"RECENTRE\">\n";
        echo "<param name=\"TB_BUT_pquery_IMG\" value=\"./images/".
            "tool_query_1.gif\">\n";
        echo "<param name=\"TB_BUT_pquery_IMG_PR\" value=\"./images/".
            "tool_query_2.gif\">\n";
        echo "<param name=\"TB_BUT_pquery_HINT\" value=".
            "\"Query Visible Layers (point/rectangle)\">\n";
        echo "<param name=\"TB_BUT_pquery_INPUT\" value=\"auto_rect\">\n";
        echo "<param name=\"TB_BUT_pquery_NAME\" value=\"ROSA_CMD\">\n";
        echo "<param name=\"TB_BUT_pquery_VALUE\" value=\"QUERY\"></applet>";        
        echo "</td>\n";
    }
    else
    {
        // otherwise draw a regular map
        echo "<td bgcolor=\"#ffffff\" width=\"".$oMap->width."\" height=\"".
                                                            $oMap->height."\">";
        echo "<input type=image src=\"".$szLocation."\" border=0 width=\"".
            $oMap->width."\" height=\"".
            $oMap->height."\" name=\"mainmap\"></td>";
    }

// end drawMainMap function
}
?>
