<?php
/**
 * MapBrowser application
 * 
 * @project     MapLab
 * @revision    $Id: treeview.php,v 1.4 2002/10/07 19:28:49 assefa Exp $
 * @purpose     This is the tree menu page's supporting php code.
 * @author      William A. Bronsema, C.E.T. (bronsema@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*****************************************************************************
 * $Log: treeview.php,v $
 * Revision 1.4  2002/10/07 19:28:49  assefa
 * Delimiter used in the treemenu file has changed from a "," to &&.
 * Changes done in server_data_manager.php.
 *
 * Revision 1.3  2002/06/30 20:15:01  pspencer
 * initial cut at register_globals=off and new session model
 *
 * Revision 1.2  2002/06/13 14:10:27  sacha
 * Change copywrite
 *
 * Revision 1.1  2002/05/16 16:52:27  bronsema
 * Initial addition
 *
 *****************************************************************************/
include( COMMON."treemenu/treemenu.php");

if (!isset($_GET["p"])) $_GET["p"] = "";

// determine if the treemenu exists
if ( file_exists( $_SESSION["gszServerDataPath"]."server.treemenu" ) )
{
    // create a new instance of the treemenu class
    $oTree = new FileTreeMenu( $_SESSION["gszServerDataPath"]."server.treemenu" );
    
    // set the title
    $oTree->setTitle("<img src=\"./images/tree_servers_list.gif\" width=20 ".
                     "height=20><font face=\"Arial, Helvetica, sans-serif\" ".
                     "size=3><b>Data Stores</b></font>");
    
    // define the font
    $oTree->setFont("<font face=\"Arial, Helvetica, sans-serif\" size=2>");
    
    // set the callback function
    $oTree->setCallback("processNode");
    
    // restore the previous state
    $oTree->restoreStates($_GET["p"]);
    
    //need to override the +/- clicks with javascript to handle adding SID to all
    //reloads
    $oTree->setScript("nodeClicked");
}
else
{
    // display the default tree
    $oTree = new FileTreeMenu( "no_servers.treemenu" );
    
    // set the title
    $oTree->setTitle("<font face=\"Arial, Helvetica, sans-serif\" size=3><b>".
                                                "Data Stores</b></font>");
    // set the callback function
    $oTree->setCallback( "processNode" );
    
    // restore the previous state
    $oTree->restoreStates($_GET["p"]);

}

/**
 * format a single node in a treemenu.
 * 
 * @param $szNode - the full text from the treemenu, will start with @
 * @param $aszTree - a 2D array of table cells that will form the treemenu
 * @param $nRow - the current row (where to put this node)
 * @param $nCol - the current column (where to start this node)
 * @param $nMaxWidth - the last column that the treemenu will use, you can add
 *        additional columns after this and they will all be lined up on the
 *        right of the tree no matter how expanded it becomes
 * @return $aszTree, the treemenu array that was passed in originally
 **/
function processNode( $szNode, $szSelected, $aszTree, $nRow, $nCol, $nMaxWidth, 
                                                 $params, $hasChild, $bExpand )
{
    //strip the @ from the beginning
    $szNode = trim(substr($szNode, 1));
    
    // check for the "no_servers" call back
    if ( $szNode == "no_servers" ) 
    {
        $aszTree[$nRow][$nCol++] = "<font face=\"Arial, Helvetica, ".
                                   "sans-serif\" color=\"red\" size=2>".
                                   "&nbsp;<br>&nbsp;&nbsp;No servers have ".
                                   "been added.".
                                   "<br>&nbsp;&nbsp;Click <a href=\"javascript".
                                   ":manageServers()\">here".
                                   "</a> to add a server.</font>";
     
        // exit the function
        return $aszTree; 
    }   
    
    
    // break apart the text
    $a = explode( '&&', $szNode );
    $layer_id = $a[0];
    $name = $a[1];
    
    // determine if the node should be a link
    if ( strtoupper( substr( $layer_id, 0, 3 ) ) == "SER" )
    {
        $result  = "<FONT FACE='Arial, Helvetica, sans-serif' SIZE='2' color=\"#336699\"><b>".
                                                            $name."</b></font>";                        
    }
    else
    {
        $result  = "<FONT FACE='Arial, Helvetica, sans-serif' SIZE='2'>".
                                    "<a href='javascript:addLayer(".$layer_id;
        $result .= ")'>".$name."</a></font>";
    }
    
    $aszTree[$nRow][$nCol++] = $result;
 
    // return the node
    return $aszTree;
    
// end processNode function    
}
?>
